<script setup lang="ts">
// import { useEmployStore } from '@/stores/employee';
import type { Employee } from '@/types/Employee'
import { nextTick, ref } from 'vue'
import { onMounted } from 'vue'
import type { VForm } from 'vuetify/components'
import SalaryDialog from './SalaryDialog.vue'
import { useLoadingStore } from '@/stores/loading'
import { useEmployStore } from '@/stores/employee'
import { useStatusStore } from '@/stores/status'
import { useInsertTempStore } from '@/stores/insertemp'

const employeeStore = useEmployStore()
const usestatusStore = useStatusStore()
//กำหนดหัวData table
const headers = [
  {
    title: 'Employee ID',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Photo',
    key: 'image'
  },
  {
    title: 'Employee Name',
    key: 'name',
    value: 'name'
  },
  {
    title: 'Tel',
    key: 'tel',
    value: 'tel'
  },
  {
    title: 'Status',
    key: 'status',
    value: (item: any | Employee) => item.status.name
  },
  {
    title: 'Slary',
    key: 'salary',
    value: 'salary'
  },
  { title: '', key: 'actions', sortable: false }
]
const loadingStore = useLoadingStore()
const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const dialog2 = ref(false)
const dialogDelete = ref(false)
const loading = ref(false)
const insertTempStore = useInsertTempStore()

// ข้อมูล

let editedIndex = -1
function onSubmit() {}

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    employeeStore.clearForm()
  })
}
async function deleteItemConfirm() {
  await employeeStore.deleteEmployee()
  closeDelete()
}
async function editItem(item: Employee) {
  if (!item.id) return
  await employeeStore.getEmployee(item.id)
  dialog.value = true
}
async function deleteItem(item: Employee) {
  if (!item.id) return
  await employeeStore.getEmployee(item.id)
  dialogDelete.value = true
  editedIndex = -1
}
function closeDialog() {
  dialog.value = false
  nextTick(() => {
    employeeStore.clearForm()
  })
}

async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  await employeeStore.saveEmployee()
  closeDialog()
}

function searchfor(Input: string) {
  employeeStore.Employees = employeeStore.Employees.filter(function (Employees) {
    return (
      Employees.name.toLowerCase().includes(Input.toLowerCase()) || Employees.tel.includes(Input)
    )
  })
}
const input = ref('')
function extra() {
  searchfor(input.value)
}

const createEmployee = () => {
  insertTempStore.createEmployee(employeeStore.editedEmployee)
}
const search = ref('')
const colse2Dialog = () => {
  dialog2.value = false
}

onMounted(() => {
  employeeStore.getEmployees()
})
</script>

<template>
  <div>
    <v-data-table
      :headers="headers"
      :search="search"
      :items="employeeStore.Employees"
      class="custom-datatable"
    >
      <template v-slot:top>
        <v-toolbar flat style="background-color: rgb(247, 156, 82)">
          <v-toolbar-title style="color: white; font-weight: bold; font-size: 30px"
            >Employee</v-toolbar-title
          >
          <v-spacer></v-spacer>

          <v-text-field
            rounded
            v-model="search"
            label="Search"
            prepend-inner-icon="mdi-magnify"
            variant="solo"
            hide-details
            single-line
          ></v-text-field>
          <!-- ตรงนี้เป็นปุ่มรีนะ -->
          <v-btn icon="mdi-cached" color="text-black" @click="employeeStore.getEmployees"></v-btn>
          <v-divider class="mx-4" inset vertical></v-divider>
          <v-spacer></v-spacer>
          <!-- ใส่Dialog -->
          <SalaryDialog />

          <v-dialog v-model="dialog" persistent width="1024">
            <template v-slot:activator="{ props }">
              <v-btn
                prepend-icon="mdi-plus"
                outlined
                v-bind="props"
                style="color: white; background-color: green"
                >New Employee</v-btn
              >
            </template>

            <v-card elevation="5">
              <v-card-title>
                <span class="text-h5">Employee Profile</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="employeeStore.editedEmployee.name"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Name"
                        >
                        </v-text-field>
                      </v-col>

                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="employeeStore.editedEmployee.tel"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          clearable
                          label="Tel"
                        >
                        </v-text-field>
                      </v-col>
                    </v-row>
                    <v-row>
                      <v-col cols="12" sm="12" md="4">
                        <v-combobox
                          v-model="employeeStore.editedEmployee.status"
                          :items="usestatusStore.status"
                          item-title="name"
                          item-value="id"
                          label="Select status"
                          :return-object="false"
                        >
                        </v-combobox>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="employeeStore.editedEmployee.salary"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          clearable
                          label="Salary"
                          type="number"
                        >
                        </v-text-field>
                      </v-col>
                      <v-col cols="6">
                        <v-img
                          :src="
                            'http://localhost:4000/images/employees/' +
                            employeeStore.editedEmployee.image
                          "
                          width="200"
                        ></v-img>
                      </v-col>
                      <v-col cols="6">
                        <v-file-input
                          v-model="employeeStore.editedEmployee.files"
                          :rules="[
                            (value) => {
                              return (
                                !value ||
                                !value.length ||
                                value[0].size < 2000000 ||
                                'Avatar size should be less than 2 MB!'
                              )
                            }
                          ]"
                          accept="image/png, image/jpeg, image/bmp"
                          label="Image"
                          placeholder="Pick an image"
                          prepend-icon="mdi-camera"
                        ></v-file-input>
                      </v-col>
                    </v-row>
                    <v-row>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="employeeStore.editedEmployee.dateIn"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          clearable
                          label="DateIn"
                          type="date"
                        >
                        </v-text-field>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-form>
                <small>*indicates required field</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDialog()"> Close </v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>

          <v-dialog v-model="dialogDelete" max-width="500px">
            <v-card>
              <v-card-title class="text-h5"
                >Are you sure you want to delete this item?</v-card-title
              >
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDelete">Cancel</v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="deleteItemConfirm">OK</v-btn>
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" color="blue-accent-4" class="me-2" @click="editItem(item)">
          mdi-pencil
        </v-icon>
        <v-icon size="small" color="red-accent-4" @click="deleteItem(item)"> mdi-delete </v-icon>
      </template>
      <template v-slot:no-data>
        <v-btn color="primary" @click="employeeStore.getEmployees"> Reset </v-btn>
      </template>
      <template v-slot:[`item.image`]="{ item }">
        <v-img :src="'http://localhost:4000/images/employees/' + item.image" width="100"></v-img>
      </template>
    </v-data-table>
  </div>
</template>
<style scoped>
.custom-datatable th {
  background-color: rgb(236, 235, 235);
  color: black;
  font-weight: bold !important; 
  font-size: 15px; /* Adjust the font size as needed */
}
</style>
